#include "testlib.h"
#include "bits/stdc++.h"

using namespace std;
const int MAXN = 100000, MAXM = MAXN, MAXL = 1e9, MAXV = 1000;

set <int> s;

int main() {    
    registerValidation();
    
    int n = inf.readInt(0, MAXN); inf.readSpace();
    int m = inf.readInt(0, MAXM); inf.readSpace();
    int l = inf.readInt(max(n, 3), MAXL); inf.readSpace();
    int v = inf.readInt(1, MAXV); inf.readEoln();

    for (int i = 0; i < n; ++i) {
        int num = inf.readInt(0, l - 1);
        if (i < n - 1) {
            inf.readSpace();
        }
        ensure(!s.count(num));
        s.insert(num);
    }

    inf.readEoln();

    for (int i = 0; i < m; ++i) {
        char ch = inf.readChar(); inf.readSpace();
        ensure(ch == '+' || ch == '-');
        int num = inf.readInt(0, l - 1);
        if (ch == '-') {
            ensure(s.count(num));
            s.erase(num);
        } else {
            ensure(!s.count(num));
            s.insert(num);
        }
        inf.readEoln();        
    }

    inf.readEof();
    return 0;
}
